## visad.cluster
Class RemoteClientPartitionedFieldImpl

    java.lang.Object
      java.rmi.server.RemoteObject
          java.rmi.server.RemoteServer
              java.rmi.server.UnicastRemoteObject
                  visad.RemoteThingImpl
                      visad.RemoteDataImpl
                          visad.cluster.RemoteClusterDataImpl
                              visad.cluster.RemoteClientDataImpl
                                  visad.cluster.RemoteClientPartitionedFieldImpl

All Implemented Interfaces:
  Data, Field, Function, Remote, RemoteClientData, RemoteClientField, RemoteClusterData, RemoteData, RemoteField, RemoteThing, Serializable, Thing

public class RemoteClientPartitionedFieldImpl
extends RemoteClientDataImpl
implements RemoteClientField

RemoteClientPartitionedFieldImpl is the class for cluster client VisAD Field data objects.

See Also:
  Serialized Form

Field Summary

Fields inherited from class visad.RemoteDataImpl
``

Fields inherited from class visad.RemoteThingImpl
``

Fields inherited from class java.rmi.server.RemoteObject
`ref`

Fields inherited from interface visad.Data

`ABS, ACOS, ACOS_DEGREES, ADD, ASIN, ASIN_DEGREES, ATAN, ATAN_DEGREES, ATAN2, ATAN2_DEGREES, CEIL, COS, COS_DEGREES, DEGREES_TO_RADIANS, DEPENDENT, DIVIDE, EXP, FLOOR, INDEPENDENT, INV_ATAN2, INV_ATAN2_DEGREES, INV_DIVIDE, INV_POW, INV_REMAINDER, INV_SUBTRACT, LOG, MAX, MIN, MULTIPLY, NEAREST_NEIGHBOR, NEGATE, NO_ERRORS, NOP, POW, RADIANS_TO_DEGREES, REMAINDER, RINT, ROUND, SIN, SIN_DEGREES, SQRT, SUBTRACT, TAN, TAN_DEGREES, WEIGHTED_AVERAGE`

Constructor Summary
`RemoteClientPartitionedFieldImpl(FunctionType t, Set s)` must call setupClusterData after constructor to finish the "construction"

Method Summary
`Data` `adjustSamplingError(Data error, int error_mode)` return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode
`double[][]` `computeRanges(RealType[] reals)` compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D
`DataShadow` `computeRanges(ShadowType type, DataShadow shadow)` Recursive version of computeRanges(), called down through Data object tree.
`DataShadow` `computeRanges(ShadowType type, int n)` Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector.
`Data` `derivative(int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode
`Data` `derivative(MathType[] derivType_s, int error_mode)` return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Data`

`derivative(RealTuple location, RealType[] d_partial_s, MathType[] derivType_s, int error_mode)`
return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

`Function` `derivative(RealType d_partial, int error_mode)` return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Function` `derivative(RealType d_partial, MathType derivType, int error_mode)` return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode
`Enumeration` `domainEnumeration()` Here's how to use this: for (Enumeration e = field.domainEnumeration() ; e.hasMoreElements(); ) { RealTuple domain_sample = (RealTuple) e.nextElement(); Data range = field.evaluate(domain_sample); }
`Field` `domainFactor(RealType factor)` factor Field domain into domains of two nested Fields
`Field` `domainMultiply()` combine domains of two outermost nested Fields into a single domain and Field
`Field` `domainMultiply(int depth)` combine domains to depth, if possible
`Data` `evaluate(Real domain)` Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(Real domain, int sampling_mode, int error_mode)` Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors
`Data` `evaluate(RealTuple domain)` Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)
`Data` `evaluate(RealTuple domain, int sampling_mode, int error_mode)` Evaluate this Function with non-default modes for resampling and errors
`Field` `extract(int component)` assumes the range type of this is a Tuple and returns a Field with the same domain as this, but whose range samples consist of the specified Tuple component of the range samples of this; in shorthand, this[].component
`Unit[]` `getDefaultRangeUnits()` get default range Unit-s for 'Flat' components
`CoordinateSystem` `getDomainCoordinateSystem()` Get the CoordinateSystem associated with the domain RealTuple
`int` `getDomainDimension()` Get the dimension (number of Real components) of this Function's domain
`Set` `getDomainSet()` get the domain Set
`Unit[]` `getDomainUnits()` Get the default Units of the Real components of the domain.
`float[][]` `getFloats()` invokes getFloats(true)

`float[][]`

`getFloats(boolean copy)`
get the 'Flat' components of this Field's range values in their default range Units (as defined by the range of the Field's FunctionType); if the range type is a RealType it is a 'Flat' component, if the range type is a TupleType its RealType components and RealType components of its RealTupleType components are all 'Flat' components; the return array is dimensioned: float[number_of_flat_components][number_of_range_samples]; return a copy if copy == true

`int` `getLength()` get number of samples
`CoordinateSystem[]` `getRangeCoordinateSystem()` get range CoordinateSystem for 'RealTuple' range; index may enumerate samples, if they differ
`CoordinateSystem[]` `getRangeCoordinateSystem(int i)` get range CoordinateSystem for 'RealTuple' components; index may enumerate samples, if they differ
`Unit[][]` `getRangeUnits()` get range Unit-s for 'Flat' components; second index may enumerate samples, if they differ
`Data` `getSample(int index)` get the range value at the index-th sample
`String[][]` `getStringValues()` get String values for Text components
`MathType` `getType()`
`double[][]` `getValues()` invokes getValues(true)

`double[][]`

`getValues(boolean copy)`
get the 'Flat' components of this Field's range values in their default range Units (as defined by the range of the Field's FunctionType); if the range type is a RealType it is a 'Flat' component, if the range type is a TupleType its RealType components and RealType components of its RealTupleType components are all 'Flat' components; the return array is dimensioned: double[number_of_flat_components][number_of_range_samples]; return a copy if copy == true

`boolean` `isFlatField()` return true if this a FlatField or a RemoteField adapting a FlatField
`boolean` `isMissing()`
`String` `longString()`
`String` `longString(String pre)`
`Field` `resample(Set set)` Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation
`Field` `resample(Set set, int sampling_mode, int error_mode)` Resample range values of this Function to domain samples in set; return a Field (i.e., a finite sampling of a Function).
`void` `setSample(int index, Data range)` set the range value at the index-th sample
`void` `setSample(int index, Data range, boolean copy)` set the range value at the index-th sample
`void` `setSample(RealTuple domain, Data range)` set the range value at the sample nearest to domain
`void` `setSample(RealTuple domain, Data range, boolean copy)` set the range value at the sample nearest to domain
`void` `setSamples(Data[] range, boolean copy)` set the range samples of the function; the order of range samples must be the same as the order of domain indices in the DomainSet; copy range objects if copy is true; should use same MathType object in each Data object in range array
`void` `setSamples(double[][] range)` set range array as range values of this Field; this must have a Flat range; the array is dimensioned float[number_of_range_components][number_of_range_samples]; the order of range values must be the same as the order of domain indices in the DomainSet
`void` `setSamples(float[][] range)` set range array as range values of this Field; this must have a Flat range; the array is dimensioned float[number_of_range_components][number_of_range_samples]; the order of range values must be the same as the order of domain indices in the DomainSet
`void` `setSamples(RemoteClientDataImpl[] range)`
`void` `setSamples(RemoteClientDataImpl[] range, boolean copy)`

Methods inherited from class visad.cluster.RemoteClientDataImpl
`binary, binary, unary, unary`

Methods inherited from class visad.cluster.RemoteClusterDataImpl
`addReference, clusterDataEquals, getClusterData, getPartitionSet, getTable, local, main, notifyReferences, removeReference, setParent, setupClusterData`

Methods inherited from class visad.RemoteDataImpl

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, ceil, ceil, changeMathType, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, log, log, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees`

Methods inherited from class visad.RemoteThingImpl
`getTick, incTick`

Methods inherited from class java.rmi.server.UnicastRemoteObject
`clone, exportObject, exportObject, exportObject, unexportObject`

Methods inherited from class java.rmi.server.RemoteServer
`getClientHost, getLog, setLog`

Methods inherited from class java.rmi.server.RemoteObject
`equals, getRef, hashCode, toString, toStub`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface visad.cluster.RemoteClusterData
`clusterDataEquals, getClusterData, setupClusterData`

Methods inherited from interface visad.Data

`abs, abs, acos, acos, acosDegrees, acosDegrees, add, add, asin, asin, asinDegrees, asinDegrees, atan, atan, atan2, atan2, atan2Degrees, atan2Degrees, atanDegrees, atanDegrees, binary, binary, ceil, ceil, changeMathType, cos, cos, cosDegrees, cosDegrees, dataClone, divide, divide, exp, exp, floor, floor, local, log, log, max, max, min, min, multiply, multiply, negate, negate, pow, pow, remainder, remainder, rint, rint, round, round, sin, sin, sinDegrees, sinDegrees, sqrt, sqrt, subtract, subtract, tan, tan, tanDegrees, tanDegrees, unary, unary`

Methods inherited from interface visad.Thing
`addReference, removeReference`

Methods inherited from interface visad.RemoteThing
`getTick, incTick`

Constructor Detail

### RemoteClientPartitionedFieldImpl

    public RemoteClientPartitionedFieldImpl(FunctionType t,
                                            Set s)
                                     throws VisADException,
                                            RemoteException

  must call setupClusterData after constructor to finish the "construction"

Method Detail

### setSamples

    public void setSamples(RemoteClientDataImpl[] range)
                    throws VisADException,
                           RemoteException

  Throws:
    `VisADException`
    `RemoteException`

### setSamples

    public void setSamples(RemoteClientDataImpl[] range,
                           boolean copy)
                    throws VisADException,
                           RemoteException

  Throws:
    `VisADException`
    `RemoteException`

### setSamples

    public void setSamples(Data[] range,
                           boolean copy)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Field`
  set the range samples of the function; the order of range samples must be the same as the order of domain indices in the DomainSet; copy range objects if copy is true; should use same MathType object in each Data object in range array

  Specified by:
    `setSamples` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSamples

    public void setSamples(double[][] range)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Field`
  set range array as range values of this Field; this must have a Flat range; the array is dimensioned float[number_of_range_components][number_of_range_samples]; the order of range values must be the same as the order of domain indices in the DomainSet

  Specified by:
    `setSamples` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSamples

    public void setSamples(float[][] range)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Field`
  set range array as range values of this Field; this must have a Flat range; the array is dimensioned float[number_of_range_components][number_of_range_samples]; the order of range values must be the same as the order of domain indices in the DomainSet

  Specified by:
    `setSamples` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getType

    public MathType getType()
                     throws VisADException,
                            RemoteException

  Specified by:
    `getType` in interface `Data`
  Overrides:
    `getType` in class `RemoteDataImpl`
  Returns:
    MathType of this Data
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### isMissing

    public boolean isMissing()
                      throws VisADException,
                             RemoteException

  Specified by:
    `isMissing` in interface `Data`
  Overrides:
    `isMissing` in class `RemoteDataImpl`
  Returns:
    flag indicating whether this Data has a missing value
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### getDomainDimension

    public int getDomainDimension()
                           throws VisADException,
                                  RemoteException

  Description copied from interface: `Function`
  Get the dimension (number of Real components) of this Function's domain

  Specified by:
    `getDomainDimension` in interface `Function`
  Returns:
    number of RealType components (n in R^n space)
  Throws:
    `VisADException`
    `RemoteException`

### getDomainSet

    public Set getDomainSet()
                     throws VisADException,
                            RemoteException

  Description copied from interface: `Field`
  get the domain Set

  Specified by:
    `getDomainSet` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getLength

    public int getLength()
                  throws RemoteException

  Description copied from interface: `Field`
  get number of samples

  Specified by:
    `getLength` in interface `Field`
  Throws:
    `RemoteException`

### getDomainUnits

    public Unit[] getDomainUnits()
                          throws VisADException,
                                 RemoteException

  Description copied from interface: `Function`
  Get the default Units of the Real components of the domain.

  Specified by:
    `getDomainUnits` in interface `Function`
  Returns:
    array of Unit-s in the same order as the RealTypes in the domain.
  Throws:
    `VisADException`
    `RemoteException`

### getDomainCoordinateSystem

    public CoordinateSystem getDomainCoordinateSystem()
                                               throws VisADException,
                                                      RemoteException

  Description copied from interface: `Function`
  Get the CoordinateSystem associated with the domain RealTuple

  Specified by:
    `getDomainCoordinateSystem` in interface `Function`
  Returns:
    CoordinateSystem of the domain
  Throws:
    `VisADException`
    `RemoteException`

### getSample

    public Data getSample(int index)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Field`
  get the range value at the index-th sample

  Specified by:
    `getSample` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSample

    public void setSample(RealTuple domain,
                          Data range,
                          boolean copy)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Field`
  set the range value at the sample nearest to domain

  Specified by:
    `setSample` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSample

    public void setSample(RealTuple domain,
                          Data range)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Field`
  set the range value at the sample nearest to domain

  Specified by:
    `setSample` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSample

    public void setSample(int index,
                          Data range,
                          boolean copy)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Field`
  set the range value at the index-th sample

  Specified by:
    `setSample` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### setSample

    public void setSample(int index,
                          Data range)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Field`
  set the range value at the index-th sample

  Specified by:
    `setSample` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### extract

    public Field extract(int component)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Field`
  assumes the range type of this is a Tuple and returns a Field with the same domain as this, but whose range samples consist of the specified Tuple component of the range samples of this; in shorthand, this[].component

  Specified by:
    `extract` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### domainMultiply

    public Field domainMultiply()
                         throws VisADException,
                                RemoteException

  Description copied from interface: `Field`
  combine domains of two outermost nested Fields into a single domain and Field

  Specified by:
    `domainMultiply` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### domainMultiply

    public Field domainMultiply(int depth)
                         throws VisADException,
                                RemoteException

  Description copied from interface: `Field`
  combine domains to depth, if possible

  Specified by:
    `domainMultiply` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### domainFactor

    public Field domainFactor(RealType factor)
                       throws VisADException,
                              RemoteException

  Description copied from interface: `Field`
  factor Field domain into domains of two nested Fields

  Specified by:
    `domainFactor` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getValues

    public double[][] getValues()
                         throws VisADException,
                                RemoteException

  Description copied from interface: `Field`
  invokes getValues(true)

  Specified by:
    `getValues` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getValues

    public double[][] getValues(boolean copy)
                         throws VisADException,
                                RemoteException

  Description copied from interface: `Field`
  get the 'Flat' components of this Field's range values in their default range Units (as defined by the range of the Field's FunctionType); if the range type is a RealType it is a 'Flat' component, if the range type is a TupleType its RealType components and RealType components of its RealTupleType components are all 'Flat' components; the return array is dimensioned: double[number_of_flat_components][number_of_range_samples]; return a copy if copy == true

  Specified by:
    `getValues` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getFloats

    public float[][] getFloats()
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Field`
  invokes getFloats(true)

  Specified by:
    `getFloats` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getFloats

    public float[][] getFloats(boolean copy)
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Field`
  get the 'Flat' components of this Field's range values in their default range Units (as defined by the range of the Field's FunctionType); if the range type is a RealType it is a 'Flat' component, if the range type is a TupleType its RealType components and RealType components of its RealTupleType components are all 'Flat' components; the return array is dimensioned: float[number_of_flat_components][number_of_range_samples]; return a copy if copy == true

  Specified by:
    `getFloats` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getStringValues

    public String[][] getStringValues()
                               throws VisADException,
                                      RemoteException

  Description copied from interface: `Field`
  get String values for Text components

  Specified by:
    `getStringValues` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getDefaultRangeUnits

    public Unit[] getDefaultRangeUnits()
                                throws VisADException,
                                       RemoteException

  Description copied from interface: `Field`
  get default range Unit-s for 'Flat' components

  Specified by:
    `getDefaultRangeUnits` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getRangeUnits

    public Unit[][] getRangeUnits()
                           throws VisADException,
                                  RemoteException

  Description copied from interface: `Field`
  get range Unit-s for 'Flat' components; second index may enumerate samples, if they differ

  Specified by:
    `getRangeUnits` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getRangeCoordinateSystem

    public CoordinateSystem[] getRangeCoordinateSystem()
                                                throws VisADException,
                                                       RemoteException

  Description copied from interface: `Field`
  get range CoordinateSystem for 'RealTuple' range; index may enumerate samples, if they differ

  Specified by:
    `getRangeCoordinateSystem` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### getRangeCoordinateSystem

    public CoordinateSystem[] getRangeCoordinateSystem(int i)
                                                throws VisADException,
                                                       RemoteException

  Description copied from interface: `Field`
  get range CoordinateSystem for 'RealTuple' components; index may enumerate samples, if they differ

  Specified by:
    `getRangeCoordinateSystem` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### isFlatField

    public boolean isFlatField()
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Field`
  return true if this a FlatField or a RemoteField adapting a FlatField

  Specified by:
    `isFlatField` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### domainEnumeration

    public Enumeration domainEnumeration()
                                  throws VisADException,
                                         RemoteException

  Description copied from interface: `Field`

         Here's how to use this:

         for (Enumeration e = field.domainEnumeration() ; e.hasMoreElements(); ) {
           RealTuple domain_sample = (RealTuple) e.nextElement();
           Data range = field.evaluate(domain_sample);
         }

  Specified by:
    `domainEnumeration` in interface `Field`
  Throws:
    `VisADException`
    `RemoteException`

### evaluate

    public Data evaluate(Real domain)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function at domain; for 1-D domains use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(Real domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function, for 1-D domains, with non-default modes for resampling and errors

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function at domain; use default modes for resampling (Data.WEIGHTED_AVERAGE) and errors (Data.NO_ERRORS)

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### evaluate

    public Data evaluate(RealTuple domain,
                         int sampling_mode,
                         int error_mode)
                  throws VisADException,
                         RemoteException

  Description copied from interface: `Function`
  Evaluate this Function with non-default modes for resampling and errors

  Specified by:
    `evaluate` in interface `Function`
  Parameters:
    `domain` - value to evaluate at.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to evaluate function
    `RemoteException` - Java RMI exception

### resample

    public Field resample(Set set)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Function`
  Return a Field of Function values at the samples in set using default sampling_mode (WEIGHTED_AVERAGE) and error_mode (NO_ERRORS); This combines unit conversions, coordinate transforms, resampling and interpolation

  Specified by:
    `resample` in interface `Function`
  Parameters:
    `set` - finite sampling values for the function.
  Returns:
    Data object corresponding to the function value at that domain. may return a missing data object of the same type as the Function's range.
  Throws:
    `RemoteException` - Java RMI exception
    `VisADException` - unable to resample function

### resample

    public Field resample(Set set,
                          int sampling_mode,
                          int error_mode)
                   throws VisADException,
                          RemoteException

  Description copied from interface: `Function`
  Resample range values of this Function to domain samples in set; return a Field (i.e., a finite sampling of a Function). Use the specified sampling_mode and error_mode. This combines unit conversions, coordinate transforms, resampling and interpolation

  Specified by:
    `resample` in interface `Function`
  Parameters:
    `set` - finite sampling values for the function.
    `sampling_mode` - type of interpolation to perform (e.g., Data.WEIGHTED_AVERAGE, Data.NEAREST_NEIGHBOR)
    `error_mode` - type of error estimation to perform (e.g., Data.INDEPENDENT, Data.DEPENDENT, Data.NO_ERRORS)
  Returns:
    Data object corresponding to the function value at that domain, using the sampling_mode and error_modes specified. May return a missing data object of the same type as the Function's range.
  Throws:
    `VisADException` - unable to resample function
    `RemoteException` - Java RMI exception

### derivative

    public Data derivative(RealTuple location,
                           RealType[] d_partial_s,
                           MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to the RealTypes in d_partial_s; the RealTypes in d_partial_s may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Data derivative(MathType[] derivType_s,
                           int error_mode)
                    throws VisADException,
                           RemoteException

  Description copied from interface: `Function`
  return the tuple of derivatives of this Function with respect to all RealType components of its domain RealTuple; set result MathTypes of tuple components to derivType_s; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Function derivative(RealType d_partial,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Function`
  return the derivative of this Function with respect to d_partial; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### derivative

    public Function derivative(RealType d_partial,
                               MathType derivType,
                               int error_mode)
                        throws VisADException,
                               RemoteException

  Description copied from interface: `Function`
  return the derivative of this Function with respect to d_partial; set result MathType to derivType; d_partial may occur in this Function's domain RealTupleType, or, if the domain has a CoordinateSystem, in its Reference RealTupleType; propogate errors according to error_mode

  Specified by:
    `derivative` in interface `Function`
  Throws:
    `VisADException`
    `RemoteException`

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    DataShadow shadow)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  Recursive version of computeRanges(), called down through Data object tree.

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `shadow` - DataShadow instance whose contained double[][] array and animation sampling Set are modified according to RealType values in this, and used as return value
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### computeRanges

    public DataShadow computeRanges(ShadowType type,
                                    int n)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  Compute ranges of values for each of 'n' RealTypes in DisplayImpl.RealTypeVector. Called from DataRenderer with n = DisplayImpl.getScalarCount().

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Parameters:
    `type` - ShadowType generated for MathType of this
    `n` - number of RealTypes in DisplayImpl.RealTypeVector
  Returns:
    DataShadow instance containing double[][] array of RealType ranges, and an animation sampling Set
  Throws:
    `VisADException` - a VisAD error occurred
    `RemoteException` - an RMI error occurred

### computeRanges

    public double[][] computeRanges(RealType[] reals)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  compute ranges of values in this of given RealTypes, using a dummy DisplayImplJ2D

  Specified by:
    `computeRanges` in interface `Data`
  Overrides:
    `computeRanges` in class `RemoteDataImpl`
  Returns:
    double[reals.length][2] giving the low and high value in this for each RealType in reals
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### adjustSamplingError

    public Data adjustSamplingError(Data error,
                                    int error_mode)
                             throws VisADException,
                                    RemoteException

  Description copied from interface: `Data`
  return a clone of this, except with ErrorEstimates combined with values in error, according to error_mode

  Specified by:
    `adjustSamplingError` in interface `Data`
  Overrides:
    `adjustSamplingError` in class `RemoteDataImpl`
  Parameters:
    `error` -
    `error_mode` - may be Data.INDEPENDENT, Data.DEPENDENT or Data.NO_ERRORS;
  Returns:
    clone of this, except with ErrorEstimates set according to values in error
  Throws:
    `RemoteException` - an RMI error occurred
    `VisADException` - a VisAD error occurred

### longString

    public String longString()
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Overrides:
    `longString` in class `RemoteDataImpl`
  Returns:
    a longer String than returned by toString()
  Throws:
    `VisADException`
    `RemoteException`

### longString

    public String longString(String pre)
                      throws VisADException,
                             RemoteException

  Specified by:
    `longString` in interface `Data`
  Overrides:
    `longString` in class `RemoteDataImpl`
  Parameters:
    `pre` - String added to start of each line
  Returns:
    a longer String than returned by toString(), indented by pre (a string of blanks)
  Throws:
    `VisADException`
    `RemoteException`